## libonvif 1.4.4

=== CMakeLists.txt ===
#*******************************************************************************
# libonvif/CMakeLists.txt
#
# Copyright (c) 2022 Stephen Rhodes 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#******************************************************************************/

cmake_minimum_required(VERSION 3.17)

project(libonvif-pkg VERSION 1.4.4)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

if(WIN32)
    add_compile_options("/EHsc")
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    set(BUILD_SHARED_LIBS TRUE)
else()
    set(CMAKE_CXX_FLAGS "-D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wformat -Werror=format-security")
endif()

include(GNUInstallDirs)
set(CMAKE_INSTALL_INCLUDEDIR "include/${CMAKE_LIBRARY_ARCHITECTURE}")

add_subdirectory(libonvif)
add_subdirectory(onvif-util)

if (BUILD_GUI)

    add_subdirectory(libavio)
    add_subdirectory(onvif-gui)

    install(TARGETS onvif-gui DESTINATION bin)
    if (WIN32)
        install(TARGETS avio 
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib
            RUNTIME DESTINATION bin
            COMPONENT library
        )
    else()
        install(TARGETS avio DESTINATION "${CMAKE_INSTALL_LIBDIR}/")
    endif()

endif()

install(TARGETS onvif-util DESTINATION bin)

if (WIN32)
    install(TARGETS onvif 
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
        COMPONENT library
    )
else()
    install(TARGETS onvif DESTINATION "${CMAKE_INSTALL_LIBDIR}/")
endif()

install(FILES libonvif/include/onvif.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
INSTALL(FILES onvif-util/docs/onvif-util.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
INSTALL(FILES onvif-gui/docs/onvif-gui.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)

=== libavio/CMakeLists.txt ===
#*******************************************************************************
# libavio/CMakeLists.txt
#
# Copyright (c) 2022 Stephen Rhodes 
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#******************************************************************************/

cmake_minimum_required(VERSION 3.17)

project(libavio VERSION 1.1.0)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__STDC_CONSTANT_MACROS")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

if(WIN32)
    add_compile_options("/EHsc")
#    find_package(Iconv REQUIRED)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    set(BUILD_SHARED_LIBS TRUE)
endif()

find_package(SDL2 REQUIRED)
find_package(FFmpeg REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)

set(CMAKE_AUTOMOC ON)

add_library(avio SHARED
    src/Reader.cpp
    src/Exception.cpp
    src/Frame.cpp
    src/Decoder.cpp
    src/Filter.cpp
    src/Clock.cpp
    src/Display.cpp
    src/Encoder.cpp
    src/Writer.cpp
    src/Pipe.cpp
    src/GLWidget.cpp
    include/GLWidget.h
)

target_link_libraries(avio PRIVATE
    Qt5::Widgets
    FFmpeg::FFmpeg
    SDL2::SDL2
    pthread
)

set_target_properties(avio PROPERTIES
    SOVERSION 1
)

target_include_directories(avio PUBLIC
    include
)

=== libonvif/CMakeLists.txt ===
#*******************************************************************************
# libonvif/libonvif/CMakeLists.txt
#
# Copyright (c) 2020 Stephen Rhodes 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#******************************************************************************/

cmake_minimum_required(VERSION 3.17)

project(libonvif VERSION 1.4.4)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

if(WIN32)
    find_package(Iconv REQUIRED)
endif()

find_package(LibXml2 REQUIRED)

add_library(onvif SHARED
    src/onvif.c
    src/cencode.c
    src/sha1.c
)

target_link_libraries(onvif PRIVATE
    ${LIBXML2_LIBRARIES}
)

set_target_properties(onvif PROPERTIES
    SOVERSION 1
)

target_include_directories(onvif PUBLIC
    include
    ${Iconv_INCLUDE_DIRS}
    ${LIBXML2_INCLUDE_DIRS}
)

=== onvif-gui/CMakeLists.txt ===
#*******************************************************************************
# onvif-gui/CMakeLists.txt
#
# Copyright (c) 2022 Stephen Rhodes 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#******************************************************************************/

cmake_minimum_required(VERSION 3.17)
project(onvif-gui)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__STDC_CONSTANT_MACROS")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_package(Qt5 COMPONENTS Widgets REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

add_executable(onvif-gui
    src/admintab.cpp
    src/camera.cpp
    src/cameradialogtab.cpp
    src/cameralistmodel.cpp
    src/cameralistview.cpp
    src/camerapanel.cpp
    src/discovery.cpp
    src/filepanel.cpp
    src/imagetab.cpp
    src/logindialog.cpp
    src/main.cpp
    src/mainwindow.cpp
    src/messagepanel.cpp
    src/networktab.cpp
    src/onvifmanager.cpp
    src/ptztab.cpp
    src/settingspanel.cpp
    src/stylepanel.cpp
    src/videotab.cpp
    include/admintab.h
    include/camera.h
    include/cameradialogtab.h
    include/cameralistmodel.h
    include/cameralistview.h
    include/camerapanel.h
    include/discovery.h
    include/filepanel.h
    include/imagetab.h
    include/logindialog.h
    include/mainwindow.h
    include/messagepanel.h
    include/networktab.h
    include/onvifmanager.h
    include/ptztab.h
    include/settingspanel.h
    include/stylepanel.h
    include/videotab.h

    resources/resources.qrc
)

target_link_libraries(onvif-gui PRIVATE
    Qt5::Widgets
    onvif
    avio
)

target_include_directories(onvif-gui PUBLIC
    libonvif/include
    include
)

=== onvif-util/CMakeLists.txt ===
#*******************************************************************************
# libonvif/onvif-util/CMakeLists.txt
#
# Copyright (c) 2022 Stephen Rhodes 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#******************************************************************************/

cmake_minimum_required(VERSION 3.17)

project(onvif-util VERSION 1.1.0)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)

add_executable(onvif-util
    src/onvif-util.cpp
)

target_link_libraries(onvif-util PRIVATE
    onvif
)

target_include_directories(onvif-util PUBLIC
    libonvif/include
)

=== debian/changelog ===
libonvif (1.4.4-1) unstable; urgency=medium

  * Update release (Supersedes version 1.4.3-1).
  * Add record function
  * Add file management

  * Upload sponsored by Petter Reinholdtsen.

 -- Stephen Rhodes <sr99622@gmail.com>  Thu, 05 Jan 2023 09:46:30 +0100

libonvif (1.4.3-1) unstable; urgency=medium

  * Second release (Supersedes version 1.4.2-1).
  * Add custom gui
  * Add network selector
  * Bug fixes

  * Upload sponsored by Petter Reinholdtsen.

 -- Stephen Rhodes <sr99622@gmail.com>  Sat, 17 Dec 2022 07:06:30 +0100

libonvif (1.4.1-1) unstable; urgency=medium

  * Initial release (Closes: #1021980).

  * Upload sponsored by Petter Reinholdtsen.

 -- Stephen Rhodes <sr99622@gmail.com>  Tue, 18 Oct 2022 10:35:17 +0200

=== debian/control ===
Source: libonvif
Priority: optional
Maintainer: Stephen Rhodes <sr99622@gmail.com>
Build-Depends: debhelper-compat (= 13)
 , cmake
 , libxml2-dev
 , libavcodec-dev
 , libavdevice-dev
 , libsdl2-dev
 , qtbase5-dev
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/sr99622/libonvif/
Vcs-Browser: https://github.com/sr99622/libonvif/
Vcs-Git: https://github.com/sr99622/libonvif.git
Rules-Requires-Root: no

Package: libonvif-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libonvif1 (= ${binary:Version}), ${misc:Depends}
Description: ONVIF IP camera client library
 Implementing the client side of the ONVIF specification for communicating
 with IP enabled compatible cameras.

Package: libonvif1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ONVIF IP camera client library
 Implementing the client side of the ONVIF specification for communicating
 with IP enabled compatible cameras.

Package: onvif-tools
Section: utils
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
 , libonvif1
Description: ONVIF IP camera command line and GUI tools
 The command line tool discover will find compatible cameras on the local
 network and query each of them for their RSTP connection.
 The GUI tool onvif allow configuration of detected cameras.

=== debian/watch ===
# run the "uscan" command to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/sr99622/libonvif/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
